diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-global-routing.cc ns-3.40/src/internet/model/ipv4-global-routing.cc
--- ns-3.39/src/internet/model/ipv4-global-routing.cc	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/ipv4-global-routing.cc	2023-09-27 13:30:37.654839000 -0700
@@ -80,7 +80,7 @@
 Ipv4GlobalRouting::AddHostRouteTo(Ipv4Address dest, Ipv4Address nextHop, uint32_t interface)
 {
     NS_LOG_FUNCTION(this << dest << nextHop << interface);
-    Ipv4RoutingTableEntry* route = new Ipv4RoutingTableEntry();
+    auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateHostRouteTo(dest, nextHop, interface);
     m_hostRoutes.push_back(route);
 }
@@ -89,7 +89,7 @@
 Ipv4GlobalRouting::AddHostRouteTo(Ipv4Address dest, uint32_t interface)
 {
     NS_LOG_FUNCTION(this << dest << interface);
-    Ipv4RoutingTableEntry* route = new Ipv4RoutingTableEntry();
+    auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateHostRouteTo(dest, interface);
     m_hostRoutes.push_back(route);
 }
@@ -101,7 +101,7 @@
                                      uint32_t interface)
 {
     NS_LOG_FUNCTION(this << network << networkMask << nextHop << interface);
-    Ipv4RoutingTableEntry* route = new Ipv4RoutingTableEntry();
+    auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, nextHop, interface);
     m_networkRoutes.push_back(route);
 }
@@ -110,7 +110,7 @@
 Ipv4GlobalRouting::AddNetworkRouteTo(Ipv4Address network, Ipv4Mask networkMask, uint32_t interface)
 {
     NS_LOG_FUNCTION(this << network << networkMask << interface);
-    Ipv4RoutingTableEntry* route = new Ipv4RoutingTableEntry();
+    auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, interface);
     m_networkRoutes.push_back(route);
 }
@@ -122,7 +122,7 @@
                                         uint32_t interface)
 {
     NS_LOG_FUNCTION(this << network << networkMask << nextHop << interface);
-    Ipv4RoutingTableEntry* route = new Ipv4RoutingTableEntry();
+    auto route = new Ipv4RoutingTableEntry();
     *route = Ipv4RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, nextHop, interface);
     m_ASexternalRoutes.push_back(route);
 }
@@ -138,7 +138,7 @@
     RouteVec_t allRoutes;
 
     NS_LOG_LOGIC("Number of m_hostRoutes = " << m_hostRoutes.size());
-    for (HostRoutesCI i = m_hostRoutes.begin(); i != m_hostRoutes.end(); i++)
+    for (auto i = m_hostRoutes.begin(); i != m_hostRoutes.end(); i++)
     {
         NS_ASSERT((*i)->IsHost());
         if ((*i)->GetDest() == dest)
@@ -158,7 +158,7 @@
     if (allRoutes.empty()) // if no host route is found
     {
         NS_LOG_LOGIC("Number of m_networkRoutes" << m_networkRoutes.size());
-        for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+        for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
         {
             Ipv4Mask mask = (*j)->GetDestNetworkMask();
             Ipv4Address entry = (*j)->GetDestNetwork();
@@ -179,7 +179,7 @@
     }
     if (allRoutes.empty()) // consider external if no host/network found
     {
-        for (ASExternalRoutesI k = m_ASexternalRoutes.begin(); k != m_ASexternalRoutes.end(); k++)
+        for (auto k = m_ASexternalRoutes.begin(); k != m_ASexternalRoutes.end(); k++)
         {
             Ipv4Mask mask = (*k)->GetDestNetworkMask();
             Ipv4Address entry = (*k)->GetDestNetwork();
@@ -248,7 +248,7 @@
     if (index < m_hostRoutes.size())
     {
         uint32_t tmp = 0;
-        for (HostRoutesCI i = m_hostRoutes.begin(); i != m_hostRoutes.end(); i++)
+        for (auto i = m_hostRoutes.begin(); i != m_hostRoutes.end(); i++)
         {
             if (tmp == index)
             {
@@ -261,7 +261,7 @@
     uint32_t tmp = 0;
     if (index < m_networkRoutes.size())
     {
-        for (NetworkRoutesCI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+        for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
         {
             if (tmp == index)
             {
@@ -272,7 +272,7 @@
     }
     index -= m_networkRoutes.size();
     tmp = 0;
-    for (ASExternalRoutesCI k = m_ASexternalRoutes.begin(); k != m_ASexternalRoutes.end(); k++)
+    for (auto k = m_ASexternalRoutes.begin(); k != m_ASexternalRoutes.end(); k++)
     {
         if (tmp == index)
         {
@@ -292,7 +292,7 @@
     if (index < m_hostRoutes.size())
     {
         uint32_t tmp = 0;
-        for (HostRoutesI i = m_hostRoutes.begin(); i != m_hostRoutes.end(); i++)
+        for (auto i = m_hostRoutes.begin(); i != m_hostRoutes.end(); i++)
         {
             if (tmp == index)
             {
@@ -308,7 +308,7 @@
     }
     index -= m_hostRoutes.size();
     uint32_t tmp = 0;
-    for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
     {
         if (tmp == index)
         {
@@ -323,7 +323,7 @@
     }
     index -= m_networkRoutes.size();
     tmp = 0;
-    for (ASExternalRoutesI k = m_ASexternalRoutes.begin(); k != m_ASexternalRoutes.end(); k++)
+    for (auto k = m_ASexternalRoutes.begin(); k != m_ASexternalRoutes.end(); k++)
     {
         if (tmp == index)
         {
@@ -351,16 +351,15 @@
 Ipv4GlobalRouting::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (HostRoutesI i = m_hostRoutes.begin(); i != m_hostRoutes.end(); i = m_hostRoutes.erase(i))
+    for (auto i = m_hostRoutes.begin(); i != m_hostRoutes.end(); i = m_hostRoutes.erase(i))
     {
         delete (*i);
     }
-    for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end();
-         j = m_networkRoutes.erase(j))
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j = m_networkRoutes.erase(j))
     {
         delete (*j);
     }
-    for (ASExternalRoutesI l = m_ASexternalRoutes.begin(); l != m_ASexternalRoutes.end();
+    for (auto l = m_ASexternalRoutes.begin(); l != m_ASexternalRoutes.end();
          l = m_ASexternalRoutes.erase(l))
     {
         delete (*l);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-global-routing.h ns-3.40/src/internet/model/ipv4-global-routing.h
--- ns-3.39/src/internet/model/ipv4-global-routing.h	2023-07-05 14:23:47.845427500 -0700
+++ ns-3.40/src/internet/model/ipv4-global-routing.h	2023-09-27 13:30:37.654839000 -0700
@@ -19,10 +19,11 @@
 #ifndef IPV4_GLOBAL_ROUTING_H
 #define IPV4_GLOBAL_ROUTING_H
 
+#include "ipv4-header.h"
+#include "ipv4-routing-protocol.h"
+#include "ipv4.h"
+
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-header.h"
-#include "ns3/ipv4-routing-protocol.h"
-#include "ns3/ipv4.h"
 #include "ns3/ptr.h"
 #include "ns3/random-variable-stream.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-interface.cc ns-3.40/src/internet/model/ipv4-interface.cc
--- ns-3.39/src/internet/model/ipv4-interface.cc	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-interface.cc	2023-09-27 13:30:37.654839000 -0700
@@ -232,7 +232,7 @@
     NS_ASSERT(m_tc);
 
     // is this packet aimed at a local interface ?
-    for (Ipv4InterfaceAddressListCI i = m_ifaddrs.begin(); i != m_ifaddrs.end(); ++i)
+    for (auto i = m_ifaddrs.begin(); i != m_ifaddrs.end(); ++i)
     {
         if (dest == (*i).GetLocal())
         {
@@ -271,7 +271,7 @@
         }
         else
         {
-            for (Ipv4InterfaceAddressListCI i = m_ifaddrs.begin(); i != m_ifaddrs.end(); ++i)
+            for (auto i = m_ifaddrs.begin(); i != m_ifaddrs.end(); ++i)
             {
                 if (dest.IsSubnetDirectedBroadcast((*i).GetMask()))
                 {
@@ -335,7 +335,7 @@
     if (index < m_ifaddrs.size())
     {
         uint32_t tmp = 0;
-        for (Ipv4InterfaceAddressListCI i = m_ifaddrs.begin(); i != m_ifaddrs.end(); i++)
+        for (auto i = m_ifaddrs.begin(); i != m_ifaddrs.end(); i++)
         {
             if (tmp == index)
             {
@@ -360,7 +360,7 @@
     {
         NS_FATAL_ERROR("Bug in Ipv4Interface::RemoveAddress");
     }
-    Ipv4InterfaceAddressListI i = m_ifaddrs.begin();
+    auto i = m_ifaddrs.begin();
     uint32_t tmp = 0;
     while (i != m_ifaddrs.end())
     {
@@ -393,7 +393,7 @@
         return Ipv4InterfaceAddress();
     }
 
-    for (Ipv4InterfaceAddressListI it = m_ifaddrs.begin(); it != m_ifaddrs.end(); it++)
+    for (auto it = m_ifaddrs.begin(); it != m_ifaddrs.end(); it++)
     {
         if ((*it).GetLocal() == address)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-l3-protocol.cc ns-3.40/src/internet/model/ipv4-l3-protocol.cc
--- ns-3.39/src/internet/model/ipv4-l3-protocol.cc	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-l3-protocol.cc	2023-09-27 13:30:37.654839000 -0700
@@ -176,7 +176,7 @@
     NS_LOG_FUNCTION(this << protocol);
 
     L4ListKey_t key = std::make_pair(protocol->GetProtocolNumber(), -1);
-    L4List_t::iterator iter = m_protocols.find(key);
+    auto iter = m_protocols.find(key);
     if (iter == m_protocols.end())
     {
         NS_LOG_WARN("Trying to remove an non-existent default protocol "
@@ -194,7 +194,7 @@
     NS_LOG_FUNCTION(this << protocol << interfaceIndex);
 
     L4ListKey_t key = std::make_pair(protocol->GetProtocolNumber(), interfaceIndex);
-    L4List_t::iterator iter = m_protocols.find(key);
+    auto iter = m_protocols.find(key);
     if (iter == m_protocols.end())
     {
         NS_LOG_WARN("Trying to remove an non-existent protocol "
@@ -220,21 +220,19 @@
 {
     NS_LOG_FUNCTION(this << protocolNumber << interfaceIndex);
 
-    L4ListKey_t key;
-    L4List_t::const_iterator i;
     if (interfaceIndex >= 0)
     {
         // try the interface-specific protocol.
-        key = std::make_pair(protocolNumber, interfaceIndex);
-        i = m_protocols.find(key);
+        auto key = std::make_pair(protocolNumber, interfaceIndex);
+        auto i = m_protocols.find(key);
         if (i != m_protocols.end())
         {
             return i->second;
         }
     }
     // try the generic protocol.
-    key = std::make_pair(protocolNumber, -1);
-    i = m_protocols.find(key);
+    auto key = std::make_pair(protocolNumber, -1);
+    auto i = m_protocols.find(key);
     if (i != m_protocols.end())
     {
         return i->second;
@@ -266,7 +264,7 @@
 Ipv4L3Protocol::DeleteRawSocket(Ptr<Socket> socket)
 {
     NS_LOG_FUNCTION(this << socket);
-    for (SocketList::iterator i = m_sockets.begin(); i != m_sockets.end(); ++i)
+    for (auto i = m_sockets.begin(); i != m_sockets.end(); ++i)
     {
         if ((*i) == socket)
         {
@@ -316,13 +314,13 @@
 Ipv4L3Protocol::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (L4List_t::iterator i = m_protocols.begin(); i != m_protocols.end(); ++i)
+    for (auto i = m_protocols.begin(); i != m_protocols.end(); ++i)
     {
         i->second = nullptr;
     }
     m_protocols.clear();
 
-    for (Ipv4InterfaceList::iterator i = m_interfaces.begin(); i != m_interfaces.end(); ++i)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); ++i)
     {
         *i = nullptr;
     }
@@ -333,7 +331,7 @@
     m_node = nullptr;
     m_routingProtocol = nullptr;
 
-    for (MapFragments_t::iterator it = m_fragments.begin(); it != m_fragments.end(); it++)
+    for (auto it = m_fragments.begin(); it != m_fragments.end(); it++)
     {
         it->second = nullptr;
     }
@@ -464,8 +462,7 @@
 {
     NS_LOG_FUNCTION(this << address);
     int32_t interface = 0;
-    for (Ipv4InterfaceList::const_iterator i = m_interfaces.begin(); i != m_interfaces.end();
-         i++, interface++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++, interface++)
     {
         for (uint32_t j = 0; j < (*i)->GetNAddresses(); j++)
         {
@@ -484,8 +481,7 @@
 {
     NS_LOG_FUNCTION(this << address << mask);
     int32_t interface = 0;
-    for (Ipv4InterfaceList::const_iterator i = m_interfaces.begin(); i != m_interfaces.end();
-         i++, interface++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++, interface++)
     {
         for (uint32_t j = 0; j < (*i)->GetNAddresses(); j++)
         {
@@ -504,7 +500,7 @@
 {
     NS_LOG_FUNCTION(this << device);
 
-    Ipv4InterfaceReverseContainer::const_iterator iter = m_reverseInterfacesContainer.find(device);
+    auto iter = m_reverseInterfacesContainer.find(device);
     if (iter != m_reverseInterfacesContainer.end())
     {
         return (*iter).second;
@@ -650,8 +646,7 @@
             // addresses. In doubt, update all of them. Note: it's a confirmed behavior for Linux
             // routers.
             std::list<ArpCache::Entry*> entryList = arpCache->LookupInverse(from);
-            std::list<ArpCache::Entry*>::iterator iter;
-            for (iter = entryList.begin(); iter != entryList.end(); iter++)
+            for (auto iter = entryList.begin(); iter != entryList.end(); iter++)
             {
                 if ((*iter)->IsAlive())
                 {
@@ -661,7 +656,7 @@
         }
     }
 
-    for (SocketList::iterator i = m_sockets.begin(); i != m_sockets.end(); ++i)
+    for (auto i = m_sockets.begin(); i != m_sockets.end(); ++i)
     {
         NS_LOG_LOGIC("Forwarding to raw socket");
         Ptr<Ipv4RawSocketImpl> socket = *i;
@@ -834,8 +829,7 @@
     {
         NS_LOG_LOGIC("Ipv4L3Protocol::Send case 2:  limited broadcast - no route");
         uint32_t ifaceIndex = 0;
-        for (Ipv4InterfaceList::iterator ifaceIter = m_interfaces.begin();
-             ifaceIter != m_interfaces.end();
+        for (auto ifaceIter = m_interfaces.begin(); ifaceIter != m_interfaces.end();
              ifaceIter++, ifaceIndex++)
         {
             Ptr<Ipv4Interface> outInterface = *ifaceIter;
@@ -866,9 +860,7 @@
     }
 
     // 3) check: packet is destined to a subnet-directed broadcast address
-    for (Ipv4InterfaceList::iterator ifaceIter = m_interfaces.begin();
-         ifaceIter != m_interfaces.end();
-         ifaceIter++)
+    for (auto ifaceIter = m_interfaces.begin(); ifaceIter != m_interfaces.end(); ifaceIter++)
     {
         Ptr<Ipv4Interface> outInterface = *ifaceIter;
         uint32_t ifaceIndex = GetInterfaceForDevice(outInterface->GetDevice());
@@ -1019,9 +1011,7 @@
         {
             std::list<Ipv4PayloadHeaderPair> listFragments;
             DoFragmentation(packet, ipHeader, outInterface->GetDevice()->GetMtu(), listFragments);
-            for (std::list<Ipv4PayloadHeaderPair>::iterator it = listFragments.begin();
-                 it != listFragments.end();
-                 it++)
+            for (auto it = listFragments.begin(); it != listFragments.end(); it++)
             {
                 NS_LOG_LOGIC("Sending fragment " << *(it->first));
                 CallTxTrace(it->second, it->first, this, interface);
@@ -1046,9 +1036,8 @@
     NS_LOG_LOGIC("Multicast forwarding logic for node: " << m_node->GetId());
 
     std::map<uint32_t, uint32_t> ttlMap = mrtentry->GetOutputTtlMap();
-    std::map<uint32_t, uint32_t>::iterator mapIter;
 
-    for (mapIter = ttlMap.begin(); mapIter != ttlMap.end(); mapIter++)
+    for (auto mapIter = ttlMap.begin(); mapIter != ttlMap.end(); mapIter++)
     {
         uint32_t interface = mapIter->first;
         // uint32_t outputTtl = mapIter->second;  // Unused for now
@@ -1435,7 +1424,7 @@
 {
     NS_LOG_FUNCTION(this << forward);
     m_ipForward = forward;
-    for (Ipv4InterfaceList::const_iterator i = m_interfaces.begin(); i != m_interfaces.end(); i++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++)
     {
         (*i)->SetForwarding(forward);
     }
@@ -1577,13 +1566,13 @@
 
     Ptr<Fragments> fragments;
 
-    MapFragments_t::iterator it = m_fragments.find(key);
+    auto it = m_fragments.find(key);
     if (it == m_fragments.end())
     {
         fragments = Create<Fragments>();
         m_fragments.insert(std::make_pair(key, fragments));
 
-        FragmentsTimeoutsListI_t iter = SetTimeout(key, ipHeader, iif);
+        auto iter = SetTimeout(key, ipHeader, iif);
         fragments->SetTimeoutIter(iter);
     }
     else
@@ -1609,7 +1598,7 @@
 }
 
 Ipv4L3Protocol::Fragments::Fragments()
-    : m_moreFragment(0)
+    : m_moreFragment(false)
 {
     NS_LOG_FUNCTION(this);
 }
@@ -1650,9 +1639,7 @@
     {
         uint16_t lastEndOffset = 0;
 
-        for (std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator it = m_fragments.begin();
-             it != m_fragments.end();
-             it++)
+        for (auto it = m_fragments.begin(); it != m_fragments.end(); it++)
         {
             // overlapping fragments do exist
             NS_LOG_LOGIC("Checking overlaps " << lastEndOffset << " - " << it->second);
@@ -1676,7 +1663,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator it = m_fragments.begin();
+    auto it = m_fragments.begin();
 
     Ptr<Packet> p = it->first->Copy();
     uint16_t lastEndOffset = p->GetSize();
@@ -1714,7 +1701,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    std::list<std::pair<Ptr<Packet>, uint16_t>>::const_iterator it = m_fragments.begin();
+    auto it = m_fragments.begin();
 
     Ptr<Packet> p = Create<Packet>();
     uint16_t lastEndOffset = 0;
@@ -1761,7 +1748,7 @@
 {
     NS_LOG_FUNCTION(this << &key << &ipHeader << iif);
 
-    MapFragments_t::iterator it = m_fragments.find(key);
+    auto it = m_fragments.find(key);
     Ptr<Packet> packet = it->second->GetPartialPacket();
 
     // if we have at least 8 bytes, we can send an ICMP.
@@ -1837,11 +1824,8 @@
                            << std::get<3>(key) << ")");
 
     // place a new entry, on collision the existing entry iterator is returned
-    DupMap_t::iterator iter;
-    bool inserted;
-    bool isDup;
-    std::tie(iter, inserted) = m_dups.emplace(key, Seconds(0));
-    isDup = !inserted && iter->second > Simulator::Now();
+    auto [iter, inserted] = m_dups.emplace(key, Seconds(0));
+    bool isDup = !inserted && iter->second > Simulator::Now();
 
     // set the expiration event
     iter->second = Simulator::Now() + m_expire;
@@ -1894,7 +1878,7 @@
     }
     m_timeoutEventList.emplace_back(now, key, ipHeader, iif);
 
-    Ipv4L3Protocol::FragmentsTimeoutsListI_t iter = --m_timeoutEventList.end();
+    auto iter = --m_timeoutEventList.end();
 
     return (iter);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-l3-protocol.h ns-3.40/src/internet/model/ipv4-l3-protocol.h
--- ns-3.39/src/internet/model/ipv4-l3-protocol.h	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-l3-protocol.h	2023-09-27 13:30:37.654839000 -0700
@@ -20,10 +20,11 @@
 #ifndef IPV4_L3_PROTOCOL_H
 #define IPV4_L3_PROTOCOL_H
 
+#include "ipv4-header.h"
+#include "ipv4-routing-protocol.h"
+#include "ipv4.h"
+
 #include "ns3/ipv4-address.h"
-#include "ns3/ipv4-header.h"
-#include "ns3/ipv4-routing-protocol.h"
-#include "ns3/ipv4.h"
 #include "ns3/net-device.h"
 #include "ns3/nstime.h"
 #include "ns3/ptr.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-list-routing.cc ns-3.40/src/internet/model/ipv4-list-routing.cc
--- ns-3.39/src/internet/model/ipv4-list-routing.cc	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-list-routing.cc	2023-09-27 13:30:37.654839000 -0700
@@ -56,8 +56,7 @@
 Ipv4ListRouting::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (Ipv4RoutingProtocolList::iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         // Note:  Calling dispose on these protocols causes memory leak
@@ -77,9 +76,7 @@
                          << ", Time: " << Now().As(unit)
                          << ", Local time: " << m_ipv4->GetObject<Node>()->GetLocalTime().As(unit)
                          << ", Ipv4ListRouting table" << std::endl;
-    for (Ipv4RoutingProtocolList::const_iterator i = m_routingProtocols.begin();
-         i != m_routingProtocols.end();
-         i++)
+    for (auto i = m_routingProtocols.begin(); i != m_routingProtocols.end(); i++)
     {
         *stream->GetStream() << "  Priority: " << (*i).first
                              << " Protocol: " << (*i).second->GetInstanceTypeId() << std::endl;
@@ -91,8 +88,7 @@
 Ipv4ListRouting::DoInitialize()
 {
     NS_LOG_FUNCTION(this);
-    for (Ipv4RoutingProtocolList::iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         Ptr<Ipv4RoutingProtocol> protocol = (*rprotoIter).second;
@@ -110,9 +106,7 @@
     NS_LOG_FUNCTION(this << p << header.GetDestination() << header.GetSource() << oif << sockerr);
     Ptr<Ipv4Route> route;
 
-    for (Ipv4RoutingProtocolList::const_iterator i = m_routingProtocols.begin();
-         i != m_routingProtocols.end();
-         i++)
+    for (auto i = m_routingProtocols.begin(); i != m_routingProtocols.end(); i++)
     {
         NS_LOG_LOGIC("Checking protocol " << (*i).second->GetInstanceTypeId() << " with priority "
                                           << (*i).first);
@@ -182,8 +176,7 @@
     {
         downstreamLcb = MakeNullCallback<void, Ptr<const Packet>, const Ipv4Header&, uint32_t>();
     }
-    for (Ipv4RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         if ((*rprotoIter).second->RouteInput(p, header, idev, ucb, mcb, downstreamLcb, ecb))
@@ -201,8 +194,7 @@
 Ipv4ListRouting::NotifyInterfaceUp(uint32_t interface)
 {
     NS_LOG_FUNCTION(this << interface);
-    for (Ipv4RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyInterfaceUp(interface);
@@ -213,8 +205,7 @@
 Ipv4ListRouting::NotifyInterfaceDown(uint32_t interface)
 {
     NS_LOG_FUNCTION(this << interface);
-    for (Ipv4RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyInterfaceDown(interface);
@@ -225,8 +216,7 @@
 Ipv4ListRouting::NotifyAddAddress(uint32_t interface, Ipv4InterfaceAddress address)
 {
     NS_LOG_FUNCTION(this << interface << address);
-    for (Ipv4RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyAddAddress(interface, address);
@@ -237,8 +227,7 @@
 Ipv4ListRouting::NotifyRemoveAddress(uint32_t interface, Ipv4InterfaceAddress address)
 {
     NS_LOG_FUNCTION(this << interface << address);
-    for (Ipv4RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyRemoveAddress(interface, address);
@@ -250,8 +239,7 @@
 {
     NS_LOG_FUNCTION(this << ipv4);
     NS_ASSERT(!m_ipv4);
-    for (Ipv4RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->SetIpv4(ipv4);
@@ -288,8 +276,7 @@
                                                                         << " out of range");
     }
     uint32_t i = 0;
-    for (Ipv4RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++, i++)
     {
         if (i == index)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-list-routing.h ns-3.40/src/internet/model/ipv4-list-routing.h
--- ns-3.39/src/internet/model/ipv4-list-routing.h	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-list-routing.h	2023-09-27 13:30:37.658839200 -0700
@@ -18,7 +18,8 @@
 #ifndef IPV4_LIST_ROUTING_H
 #define IPV4_LIST_ROUTING_H
 
-#include "ns3/ipv4-routing-protocol.h"
+#include "ipv4-routing-protocol.h"
+
 #include "ns3/nstime.h"
 #include "ns3/simulator.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-packet-probe.h ns-3.40/src/internet/model/ipv4-packet-probe.h
--- ns-3.39/src/internet/model/ipv4-packet-probe.h	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-packet-probe.h	2023-09-27 13:30:37.658839200 -0700
@@ -23,9 +23,10 @@
 #ifndef IPV4_PACKET_PROBE_H
 #define IPV4_PACKET_PROBE_H
 
+#include "ipv4.h"
+
 #include "ns3/boolean.h"
 #include "ns3/callback.h"
-#include "ns3/ipv4.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/packet.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-raw-socket-factory-impl.h ns-3.40/src/internet/model/ipv4-raw-socket-factory-impl.h
--- ns-3.39/src/internet/model/ipv4-raw-socket-factory-impl.h	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-raw-socket-factory-impl.h	2023-09-27 13:30:37.658839200 -0700
@@ -20,7 +20,7 @@
 #ifndef IPV4_RAW_SOCKET_FACTORY_IMPL_H
 #define IPV4_RAW_SOCKET_FACTORY_IMPL_H
 
-#include "ns3/ipv4-raw-socket-factory.h"
+#include "ipv4-raw-socket-factory.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-raw-socket-impl.cc ns-3.40/src/internet/model/ipv4-raw-socket-impl.cc
--- ns-3.39/src/internet/model/ipv4-raw-socket-impl.cc	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-raw-socket-impl.cc	2023-09-27 13:30:37.658839200 -0700
@@ -400,7 +400,7 @@
 {
     NS_LOG_FUNCTION(this);
     uint32_t rx = 0;
-    for (std::list<Data>::const_iterator i = m_recv.begin(); i != m_recv.end(); ++i)
+    for (auto i = m_recv.begin(); i != m_recv.end(); ++i)
     {
         rx += (i->packet)->GetSize();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-raw-socket-impl.h ns-3.40/src/internet/model/ipv4-raw-socket-impl.h
--- ns-3.39/src/internet/model/ipv4-raw-socket-impl.h	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-raw-socket-impl.h	2023-09-27 13:30:37.658839200 -0700
@@ -1,9 +1,10 @@
 #ifndef IPV4_RAW_SOCKET_IMPL_H
 #define IPV4_RAW_SOCKET_IMPL_H
 
-#include "ns3/ipv4-header.h"
-#include "ns3/ipv4-interface.h"
-#include "ns3/ipv4-route.h"
+#include "ipv4-header.h"
+#include "ipv4-interface.h"
+#include "ipv4-route.h"
+
 #include "ns3/socket.h"
 
 #include <list>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-route.cc ns-3.40/src/internet/model/ipv4-route.cc
--- ns-3.39/src/internet/model/ipv4-route.cc	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-route.cc	2023-09-27 13:30:37.658839200 -0700
@@ -151,8 +151,7 @@
     if (ttl >= MAX_TTL)
     {
         // This TTL value effectively disables the interface
-        std::map<uint32_t, uint32_t>::iterator iter;
-        iter = m_ttls.find(oif);
+        auto iter = m_ttls.find(oif);
         if (iter != m_ttls.end())
         {
             m_ttls.erase(iter);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv4-routing-protocol.h ns-3.40/src/internet/model/ipv4-routing-protocol.h
--- ns-3.39/src/internet/model/ipv4-routing-protocol.h	2023-07-05 14:23:47.849427500 -0700
+++ ns-3.40/src/internet/model/ipv4-routing-protocol.h	2023-09-27 13:30:37.658839200 -0700
@@ -18,10 +18,10 @@
 #define IPV4_ROUTING_PROTOCOL_H
 
 #include "ipv4-header.h"
+#include "ipv4-interface-address.h"
 #include "ipv4.h"
 
 #include "ns3/callback.h"
-#include "ns3/ipv4-interface-address.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/output-stream-wrapper.h"
